package fr.jussieu.linguist.depLin;

import java.util.Iterator;
import java.util.*;
import org.jdom.*;
//import org.jdom.input.SAXBuilder;


/**
 * Copyright:    Copyright (c) 2001
 * @author kim gerdes
 * @version 1.0
 */

public class ApplyGrammar extends Thread{

    public Element topologiesRoot;
    public Element grammarRoot;
    public Element dependencyRoot;
    public Element initialField;
    public ArrayList champsObligatoires;
    public ArrayList depNodes;
    public boolean wellFormedness;
    public boolean tracing;
    public boolean stopped = false;
    public int numberTop;
    public int numberWords;
    String commentary="";
    public String story="";

    public  ArrayList placed= new ArrayList();
    public int placedNumber=0;

    public ApplyGrammar(Element grammarRoot,
                        boolean wellFormedness,
                        boolean tracing,
                        Element dependencyRoot) throws ApplyGrammarException {

	this.grammarRoot = grammarRoot;
	this.wellFormedness = wellFormedness;
	this.tracing = tracing;
	this.dependencyRoot = dependencyRoot;
	topologiesRoot = new Element("topologies");
	ArrayList depNodes = gimmeNodeList(dependencyRoot.getChild("word"));

	this.depNodes = depNodes;
	ArrayList champsObligatoires = new ArrayList();
	numberWords= depNodes.size();
	Iterator fieldIter = grammarRoot.getChildren("field").iterator();
	while (fieldIter.hasNext()) {
	    Element nextField = (Element)fieldIter.next();


	    Attribute att = nextField.getAttribute("initial");

	    if (att != null)
		{ //System.out.println(att.toString());
		//initialField = nextEl.getContent().get(0).toString();

		initialField = (Element) nextField.clone();
	    }
	    if (nextField.getAttributeValue("description").equals("!"))
		    {champsObligatoires.add(nextField.getAttributeValue("name"));
     //System.out.println(nextField.getTextNormalize());
	    }

	}
	this.champsObligatoires = champsObligatoires;



    }


//public Element getTopologies() throws ApplyGrammarException



public Element getTopologies()
{
    return topologiesRoot;
}


    public void run() // throws ApplyGrammarException
    {

	Element currentTopology = new Element("topology");
	ArrayList topMothers = new ArrayList();
	//  crer liste vide qui prendra les lments mre topologiques de chaque mot:
	for(int i=0;i<depNodes.size();i++)
             topMothers.add(null);
        currentTopology.addContent(initialField);
	// process word for root word :
	if(champPeutPrendreDesEnfants(initialField))
		{ //oui, alors, crer nouveau lment, le mettre dans le champ initial,
	    // essayer d'appliquer des box creation rules,
	    Element rootDepMot = (Element)depNodes.get(0);
	    Element rootTopMot = ((Element)rootDepMot.clone());
	    rootTopMot.detach();
	    rootTopMot.removeChildren("word");
	    initialField.addContent(rootTopMot);
	    commentary+="<font color='#3D8F77'>"+ rootTopMot.getAttributeValue("name")+"</font><br>";
	    commentary+="<font color='#123456'>placing '"
			 +rootTopMot.getAttributeValue("name")
			 +"' in "+initialField.getAttributeValue("name")+" (in position 0)</font><br>";
//	    placed.add(rootTopMot.getAttributeValue("name"));

placedNumber=1;
	    try {
		applyBoxCreation(currentTopology, 0, topMothers, initialField,rootTopMot,0,placedNumber);
	    }
	    catch (ApplyGrammarException ex) {
		ex.printStackTrace();

//		throw new ApplyGrammarException(ex.getMessage()
//			+" - while trying to apply box creation for "
//                        + rootTopMot.getAttributeValue("name")
//                        + " in " + initialField.getAttributeValue("name"));
	    }


 }

// return topologiesRoot;

    }




// process word ////////////////////////////////////////////////////////////

///****
    private void processWord(Element currentTop, int depNodeIndex,
			     ArrayList topMothers,int penalty, int plac) throws ApplyGrammarException

    {
	if(stopped) return;
	Element currentWordInDepTree = (Element)depNodes.get(depNodeIndex);
	if(tracing)
	{
	    commentary+="<font color='#3D8F77'>"+ currentWordInDepTree.getAttributeValue("name")+"</font><br>";
	}
//	ArrayList pl = (ArrayList)plac.clone();
//	pl.add(currentWordInDepTree.getAttributeValue("name"));
//	placed = (ArrayList)pl.clone();
	plac++;
	placedNumber=plac;
//		placed.size();
	boolean someCorrRuleApplied=false;

	Element currentMotherInTopTree = (Element)topMothers.get(depNodeIndex);
	Element currentMotherField = currentMotherInTopTree.getParent();
	Element currentMotherDomain = currentMotherField.getParent();



	Iterator correspondenceIter = grammarRoot.getChildren("correspondenceRule").iterator();

	while (correspondenceIter.hasNext()) {
	    String oldcommentary = commentary;
	    Element currentCorrRule = (Element)correspondenceIter.next();
	    String relation = currentCorrRule.getChildTextTrim("relation");
	    String catHead = currentCorrRule.getChildTextTrim("catHead");
	    String fieldHead = currentCorrRule.getChildTextTrim("fieldHead");
	    String catChild = currentCorrRule.getChildTextTrim("catChild");

	    String ruleCommHead = currentCorrRule.getChildTextTrim("commHead");
	    if (ruleCommHead == null) ruleCommHead = "?";

	    String ruleCommChild = currentCorrRule.getChildTextTrim("commChild");
	    if (ruleCommChild == null) ruleCommChild = "?";

	    String commHead = currentMotherInTopTree.getAttributeValue("comm");
	    if (commHead == null) commHead = "?";

	    String commChild = currentWordInDepTree.getAttributeValue("comm");
	    if (commChild == null) commChild = "?";

	    if (  // la rgle s'applique ?
		 (relation.equals("?")  ||
		 relation.equals(currentWordInDepTree.getAttributeValue("relation")))
		 && (catHead.equals("?") ||
		 currentMotherInTopTree.getAttributeValue("cat").equals(catHead))
		 && (fieldHead.equals("?") ||
		 currentMotherField.getAttributeValue("name").equals(fieldHead))
		 && (catChild.equals("?") ||
		 currentWordInDepTree.getAttributeValue("cat").equals(catChild))
		 && (ruleCommHead.equals("?") || commHead.equals("?") ||
		 ruleCommHead.equals(commHead))
		 && (ruleCommChild.equals("?") || commChild.equals("?") ||
		 ruleCommChild.equals(commChild))
		 )
		    { // oui, alors chercher un champ qui convient pour le dpendant
		if(tracing)
		{
		    commentary+="applying correspondence rule '"
		 +currentCorrRule.getAttributeValue("title")+"' on '"
		 +currentWordInDepTree.getAttributeValue("name")+"' <br>";
		}

		someCorrRuleApplied=true;
		String fieldChild = currentCorrRule.getChildTextTrim("fieldChild");
		int maxDomainBorder =
			Integer.parseInt(currentCorrRule.getChildTextTrim("maxDomainBorder"));
		int penaltyDeRegle =
			Integer.parseInt(currentCorrRule.getChildTextTrim("penalty"));
		try
		{
		    findField(currentTop, depNodeIndex, currentMotherDomain, fieldChild,
			      topMothers, maxDomainBorder, penalty+penaltyDeRegle,0, plac);
		}
		catch (ApplyGrammarException ex)
		{
		    ex.printStackTrace();
		    throw new ApplyGrammarException(ex.getMessage()
			    +"! couldn't find the field "
                            + fieldChild + " in "+currentTop.getAttributeValue("name"));
		}
	    } //fi
	    commentary = oldcommentary;
	} //end while

	if(!someCorrRuleApplied)
	{
	    String announcement = " - couldn't place the element "
			 +currentWordInDepTree.getAttributeValue("name")
			   +"<br>";
	    commentary ="<br>something that didn't work out :<br>"+commentary+ announcement;
	    story += commentary;
	}

    }


///***
    private void findField(Element currentTop, int depNodeIndex,
			   Element currentDomain,String fieldName,
      ArrayList topMothers,
      int maxDomainBorder, int penalty,int internalPenalty, int plac) throws ApplyGrammarException

    {
if(stopped) return;
	Iterator fieldIter = currentDomain.getChildren("field").iterator();

	while (fieldIter.hasNext())
	{
	    Element nextField = (Element)fieldIter.next();


	    if (nextField.getAttributeValue("name").equals(fieldName))
	    {

		addWordToField(currentTop, depNodeIndex,
			       topMothers, nextField, penalty+internalPenalty, plac);
	    }
	}
	// test higher fields of the current Mother Field (emancipation)
	int permeabilityOfDomain;
//if (currentDomain == null||currentDomain.getAttributeValue("permeability")==null) return;
	try {
	    permeabilityOfDomain = Integer.parseInt(currentDomain.getAttributeValue("permeability"));
	}
	catch (Exception ex) {
	    String text;
	    if(currentDomain.getName()=="topology")
	     text = "the first element couldn't create a box in the initial field !!! ";
            else text = "Couldn't determine the permeability of "+ currentDomain.getAttributeValue("name")+" !";

	 throw new ApplyGrammarException(text);
	}



	if (currentDomain.getParent().getParent().getName().equals("box")
	    && permeabilityOfDomain <= maxDomainBorder)
	{

	    findField(currentTop, depNodeIndex, currentDomain.getParent().getParent(),
		      fieldName,topMothers,
	maxDomainBorder, penalty, (permeabilityOfDomain-1)*(internalPenalty+1), plac);

	    //!! permeabilityBoite*penalty ==> multiplication de chaque niveau
	}

    }





    private void addWordToField(Element currentTop, int depNodeIndex,
				  ArrayList topMothers, Element champ, int penalty, int plac)
	    throws ApplyGrammarException

    {
// champ doit tre descendant de topActuelle

	// eske le champ prend des ajouts ?
	if(champPeutPrendreDesEnfants(champ))

	{ // oui, alors placer dans toutes les positions
	    Element currentWordInDepTree = (Element)depNodes.get(depNodeIndex);
	    int numberChildren = champ.getChildren().size();


	    for (int compteurPlace = 0;compteurPlace <= numberChildren;compteurPlace++)
	    {
		String oldcommentary = commentary;
		Element nouveauMot = ((Element)currentWordInDepTree.clone());
		nouveauMot.detach();
		nouveauMot.removeChildren("word");

		champ.getChildren().add(compteurPlace,nouveauMot);

		if (tracing)

		commentary+="<font color='#123456'>placing '"
			 +nouveauMot.getAttributeValue("name")
			 +"' in "+champ.getAttributeValue("name")
			 +" (in position "+compteurPlace+")</font><br>";


		try {
		    applyBoxCreation(currentTop, depNodeIndex, topMothers, champ, nouveauMot, penalty, plac);
		}
		catch (ApplyGrammarException ex) {
		    ex.printStackTrace();
		    throw new ApplyGrammarException(ex.getMessage());
		}



		champ.getChildren().remove(compteurPlace);
		nouveauMot = null;
		commentary=oldcommentary;
	    }

	}

	//
    }


////****
    private void applyBoxCreation(Element topActuelle, int depNodeIndex,
				  ArrayList topMothers, Element field, Element wordInTop,
      int penalty, int plac) throws ApplyGrammarException
    {

if(stopped) return;
	boolean someRuleApplied = false;
	Iterator boxCreationIter = grammarRoot.getChildren("boxCreationRule").iterator();
	while (boxCreationIter.hasNext())
	{


	    Element nextEl = (Element)boxCreationIter.next();

	    String cat = nextEl.getChildTextTrim("cat");
	    String field1 = nextEl.getChildTextTrim("field1");
	    if (field1 == null) field1 = "?";
	    String box = nextEl.getChildTextTrim("box");
	    String field2 = nextEl.getChildTextTrim("field2");
	    if (field2 == null) field1 = "?";
	    String catWord = wordInTop.getAttributeValue("cat");
	    if (catWord == null) catWord = "?";
	    String commRule = nextEl.getChildTextTrim("comm");
	    if (commRule == null) commRule = "?";
	    String commWord = wordInTop.getAttributeValue("comm");
	    if (commWord == null) commWord = "?";




	    //rgle s'applique ?
	    if((cat.equals("?")||catWord.equals("?")||catWord.equals(cat))
	       && (field1.equals("?")|| field1.equals(field.getAttributeValue("name")))
	       && (commRule.equals("?") || commWord.equals("?")|| commRule.equals(commWord)))

	    { // oui
		someRuleApplied = true;
		if(tracing)  commentary+="applied box creation rule : '"
			     + nextEl.getAttributeValue("title")
			     + "' on '"
	                     + wordInTop.getAttributeValue("name")
	                      + "' being in "
                             + field.getAttributeValue("name")+"<br>";
  // alors trouver la bonne box description
  Iterator boxDescriptionIter = grammarRoot.getChildren("boxDescriptionRule").iterator();
  while (boxDescriptionIter.hasNext())
  {
      Element nextBox = ((Element)boxDescriptionIter.next()).getChild("box");
      if (nextBox.getAttributeValue("name").equals(box))
//          if (nextBox.getTextNormalize().equals(box))
      {//bonne box description a t trouve
	  //copier la bote de la rgle
	  Element boxAInserer = (Element)nextBox.clone();

	  if(commWord!="?") boxAInserer.setAttribute("comm",commWord);


//    if(boxAInserer.getAttributeValue("name")==field.getParent().getAttributeValue("name"))
//       throw new ApplyGrammarException(nextEl.getAttributeValue("title")
//		   +" is a problem: You're creating the box "+boxAInserer.getAttributeValue("name")
//		   +" in the field "+ field.getAttributeValue("name")
//		   +" that is itself in a box of this name");

//           Element targetField = trouverElement(boxAInserer,field2);
//           if (targetField == null)
//               System.out.println(">>>>> ERROR in box creation rule '"
//               +nextEl.getAttributeValue("title")+"'!!! - "
//               +"It does not contain the field '"
//               +field2+"'.");

//           insererElement(wordInTop,boxAInserer,targetField);
////
	  Iterator findIter = boxAInserer.getChildren("field").iterator();
	  boolean thereWasAGoodField = false;
	  while (findIter.hasNext())
	  {
	      Element nextField = (Element)findIter.next();
	      if (nextField.getAttributeValue("name").equals(field2)
		  ||field2.equals("?"))
		      {//un bon lment a t trouve
		  thereWasAGoodField = true;
		  String oldcommentary = commentary;
		  insererElement(wordInTop,boxAInserer,nextField);
		  commentary+="the element was put into "+nextField.getAttributeValue("name")+"<br>";
		  applyBoxCreation(topActuelle,depNodeIndex,topMothers, nextField,
				   wordInTop,penalty,plac);
		  commentary = oldcommentary;
		  undoInsertBox(field,wordInTop,boxAInserer);

	      }

	  }
//    return null;
	  if (!thereWasAGoodField)
	  {

       throw new ApplyGrammarException(">>> no "+field2+" in "+boxAInserer.getAttributeValue("name"));
	  }


      }
  } // fin boucle box description rules
  // attention : boucle n'applique que la 1ere box description applicable
  // ==> box description doit tre unique !

	    } // fin : if rgle est bonne

	    // boucle centrale : box description rules have possibly been applied

	} // fin boucle box creation rules

	// if no rule applied, process the next word or put out what we got.
	if (!someRuleApplied)
	{
	    commentary+="then no box creation rules applied on "+ wordInTop.getAttributeValue("name")+"<br>";
	    Element currentDepNode = (Element)depNodes.get(depNodeIndex);

	    Iterator childIter = currentDepNode.getChildren("word").iterator();
	    while (childIter.hasNext())
	    {
		Element nextChild = (Element)childIter.next();
		topMothers.set(depNodes.indexOf(nextChild),wordInTop);
	    }

	    if(depNodeIndex+1<depNodes.size())
	 processWord(topActuelle, depNodeIndex+1, topMothers, penalty,plac);
     else
	 outputTop(topActuelle,penalty);

	}
    }


    private ArrayList gimmeNodeList(Element root)
    {
	ArrayList list = new ArrayList();

	list.add(root);

	Iterator iter = root.getChildren("word").iterator();
	while (iter.hasNext())
	{
	    list.addAll(gimmeNodeList((Element)iter.next()));
	}
	return list;
    }


///****
    private void outputTop(Element topology, int penalty)
    {

if(stopped) return;
	if((!wellFormedness)||(tousLesChampsCommeIlFaut(topology)))
	{
	    // add topology to the list
	    numberTop = topologiesRoot.getChildren().size()+1;
	    Element newTop = (Element)topology.clone();
	    newTop.setAttribute("penalty",Integer.toString(penalty));
	    newTop.setName("lingtree");
	    newTop.setAttribute("number",String.valueOf(numberTop));
	    newTop.setAttribute("type","topology");

	    topologiesRoot.addContent(newTop);

	    if(tracing)
	    {
	    story += "<br><i><font color='#7D007D'>"+numberTop+". Topology - Here's the story:</font></i><br>"
	    +commentary+"____________________<br>";
//	    System.out.println("Here's the story of topology number "+numberTop+":\n"+commentary);
//	    System.out.println("------ We have now "
//			     +numberTop
//			     +" topologies. ------" );
	    }

	}
    }


//%%%%
 private   boolean champPeutPrendreDesEnfants(Element champ) {

	String des = "";

	Iterator fieldIter = grammarRoot.getChildren("field").iterator();

	while (fieldIter.hasNext()) {
	    Element nextEl = (Element)fieldIter.next();



	    if (nextEl.getAttributeValue("name").equals(champ.getAttributeValue("name")))
		    { // le bon champ a t trouv

		des = nextEl.getAttributeValue("description");

		break;
	    }

	}

	int nombreDEnfants = champ.getChildren().size();
//   int nombreDEnfants = champ.getChildren("word").size()+champ.getChildren("box").size();

	if (  des.equals("*") ||
	    (des.equals("!") && nombreDEnfants == 0) ||
	    (des.equals("?") && nombreDEnfants == 0)   )
     return true;
 else return false;

    }




//****





//****
    private boolean tousLesChampsCommeIlFaut(Element RootTopInterne)
    {
	Iterator findIter = RootTopInterne.getChildren().iterator();

	while (findIter.hasNext())
	{
	    Element nextEl = (Element)findIter.next();



//        if(nextEl.getChildTextTrim("t")!=null)
//          {

	    for (int i=0;i < champsObligatoires.size();i++)
		{if (champsObligatoires.get(i).equals(nextEl.getAttributeValue("name")))
		{if ( nextEl.getChildren().size()!=1)
		{return false;}
	    }

	    }
	    if (tousLesChampsCommeIlFaut(nextEl)==false)
	 return false;
//            }
	}
	return true;

    }



///%%%
    private  void insererElement(Element subtree,
                                 Element intruderRoot, Element placedattache)  {
      if(stopped) return;
      Element mother = subtree.getParent();
      int index = mother.getChildren().indexOf(subtree);
      subtree.detach();
      placedattache.addContent(subtree);
      // just added at the end as the field is new and childless!!!
      mother.getChildren().add(index,intruderRoot);
    }




///****
 private   void undoInsertBox(Element racine, Element subtree,
		       Element intruderRacine)  {

	subtree.detach();
	Element parentOfIntruder = intruderRacine.getParent();
	int indexIntruder = parentOfIntruder.getChildren().indexOf(intruderRacine);
	intruderRacine.detach();
	parentOfIntruder.getChildren().add(indexIntruder,subtree);

    }

    public class ApplyGrammarException extends Exception{
	ApplyGrammarException(){
	    super();
	};
	ApplyGrammarException(String message){
	    super(message);
	};
    };


}