package fr.jussieu.linguist.depLin;

import org.jdom.Document;
import org.jdom.Element;
import java.io.*;
import org.jdom.input.SAXBuilder;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import org.jdom.output.XMLOutputter;
import java.net.URI;

public class DepLinPreferences  {

  public SAXBuilder saxBuilder;

  public Document doc;
  public Element rootElement;

  public int maxFileNumber;
  public File prefFile ;

  public ArrayList depFileList;
  public ArrayList topFileList;
  public ArrayList depTopGrammFileList;
  public ArrayList topPhonoGrammFileList;

  public DepLinPreferences() {

    prefFile = new File("DepLin.preferences");
    depFileList=new ArrayList();
    topFileList=new ArrayList();
    depTopGrammFileList=new ArrayList();
    topPhonoGrammFileList=new ArrayList();
    maxFileNumber=100;
    SAXBuilder saxBuilder = new SAXBuilder();


    if (prefFile.exists())
    {

      try
      {
        doc = saxBuilder.build(prefFile);
      }
      catch (Exception eee) { eee.printStackTrace();}
      rootElement= doc.getRootElement();
      List depFiles = rootElement.getChildren("DepFile");
      for (int i = 0;i<depFiles.size() ;i++ ) {
        depFileList.add(((Element)depFiles.get(i)).getAttributeValue("uri"));
      }
      List topFiles = rootElement.getChildren("TopFile");
      for (int i = 0;i<topFiles.size() ;i++ ) {
        topFileList.add(((Element)topFiles.get(i)).getAttributeValue("uri"));
      }
      List depTopGrammFiles = rootElement.getChildren("DepTopGrammFile");
      for (int i = 0;i<depTopGrammFiles.size() ;i++ ) {
        depTopGrammFileList.add(((Element)depTopGrammFiles.get(i)).getAttributeValue("uri"));
      }
      List topPhonoGrammFiles = rootElement.getChildren("TopPhonoGrammFile");
      for (int i = 0;i<topPhonoGrammFiles.size() ;i++ ) {
//        System.out.println("iiii"+i+"ii"+topPhonoGrammFiles.get(i));

        topPhonoGrammFileList.add(((Element)topPhonoGrammFiles.get(i)).getAttributeValue("uri"));
      }


    }
    else
    {
//System.out.println("");
      rootElement = new Element("DepLinPreferences");
      doc = new Document(rootElement);
//          this.setRootElement(rootElement);




    }




  }


 synchronized ArrayList  getCorrespondingFileList(String type)
  {
    ArrayList list = new ArrayList();
//      System.out.println("type:"+type);
    if(type==null)return list;
    if(type.equals("dependency")) return depFileList;
    else if(type.equals("topology")) return topFileList;
    else if(type.equals("depTopGramm")) return depTopGrammFileList;
    else if(type.equals("topPhonoGramm")) return topPhonoGrammFileList;
    return list;
  }


synchronized  ArrayList getFileList(String type) {
    ArrayList fileList = getCorrespondingFileList(type);
//    System.out.println("--"+fileList);

    ArrayList nameList = new ArrayList();
    for (Iterator i = fileList.iterator(); i.hasNext(); ) {
      nameList.add((new File((i.next()).toString())).getName());
    }
    return nameList;
  }






//ArrayList getDepFileList() {
//   ArrayList nameList = new ArrayList();
//   for (Iterator i = depFileList.iterator(); i.hasNext(); ) {
//     nameList.add((new File((i.next()).toString())).getName());
//   }
//
//   return nameList;
//
//  }
//ArrayList getTopFileList() {
//     ArrayList nameList = new ArrayList();
//     for (Iterator i = topFileList.iterator(); i.hasNext(); ) {
//       nameList.add((new File((i.next()).toString())).getName());
//     }
//
//     return nameList;
//
//  }
//
//ArrayList getGrammFileList() {
//
//  ArrayList nameList = new ArrayList();
//     for (Iterator i = grammFileList.iterator(); i.hasNext(); ) {
//       nameList.add((new File((i.next()).toString())).getName());
//     }
//
//     return nameList;
//
//  }


 synchronized File getFileFromNumber(String type, int number)
  {
    ArrayList fileList = getCorrespondingFileList(type);
    File returnFile;
    try
    { returnFile = new File(new URI(fileList.get(number).toString())); }
    catch (Exception ex) {   returnFile = new File("*");}
    return returnFile;
  }


//  File getDepFileFromNumber(int number)
//   {
//     File returnFile;
//     try
//     { returnFile = new File(new URI(depFileList.get(number).toString())); }
//     catch (Exception ex) {   returnFile = new File("*");}
//     return returnFile;
//    }
//    File getTopFileFromNumber(int number)
//     {
//       File returnFile;
//       try
//       { returnFile = new File(new URI(topFileList.get(number).toString())); }
//       catch (Exception ex) {    returnFile = new File("*");}
//       return returnFile;
//    }
//
//    File getGramFileFromNumber(int number)
//       {
//	 File returnFile;
//	 try
//	 { returnFile = new File(new URI(grammFileList.get(number).toString())); }
//	 catch (Exception ex) {   returnFile = new File("*");}
//	 return returnFile;
//    }


synchronized  void addFile(String type, File file)
  {
    ArrayList fileList = getCorrespondingFileList(type);
    String uri = file.toURI().toString();
    if(fileList.contains(uri))
      fileList.remove(uri);
    fileList.add(0,uri);

    while(fileList.size()>maxFileNumber)
      fileList.remove(fileList.size()-1);
  }

//
//void addDepFile(File depFile)
// {
//   String uri = depFile.toURI().toString();
//   if(depFileList.contains(uri))
//     depFileList.remove(uri);
//   depFileList.add(0,uri);
//
//   while(depFileList.size()>maxFileNumber)
//     depFileList.remove(depFileList.size()-1);
//  }
//
//void addTopFile(File topFile)
//   {
//     String uri = topFile.toURI().toString();
//     if(topFileList.contains(uri))
//       topFileList.remove(uri);
//     topFileList.add(0,uri);
//
//     while(topFileList.size()>maxFileNumber)
//       topFileList.remove(topFileList.size()-1);
//  }
//
//
//void addGrammFile(File grammFile)
//{
//  String uri = grammFile.toURI().toString();
//  if(grammFileList.contains(uri))
//      grammFileList.remove(uri);
//
//  grammFileList.add(0,uri);
//
//  while(grammFileList.size()>maxFileNumber)
//      grammFileList.remove(grammFileList.size()-1);
//
//}

 synchronized void writePreferences()
  {
    try {
      FileOutputStream outStream = new FileOutputStream(prefFile);
      XMLOutputter out = new XMLOutputter();
      out.setNewlines(true);
      out.setTextNormalize(true);
      out.setIndent("  ");

      rootElement.removeChildren("DepFile");
      for (Iterator i = depFileList.iterator(); i.hasNext(); ) {
        String uri = i.next().toString();
        Element ele = new Element("DepFile");
        ele.setAttribute("uri",uri);
      rootElement.addContent(ele);        }

      rootElement.removeChildren("TopFile");
      for (Iterator i = topFileList.iterator(); i.hasNext(); ) {
        String uri = i.next().toString();
        Element ele = new Element("TopFile");
        ele.setAttribute("uri",uri);
      rootElement.addContent(ele);        }

      rootElement.removeChildren("DepTopGrammFile");
      for (Iterator i = depTopGrammFileList.iterator(); i.hasNext(); ) {
        String uri = i.next().toString();
        Element ele = new Element("DepTopGrammFile");
        ele.setAttribute("uri",uri);
      rootElement.addContent(ele);        }

      rootElement.removeChildren("TopPhonoGrammFile");
            for (Iterator i = topPhonoGrammFileList.iterator(); i.hasNext(); ) {
              String uri = i.next().toString();
              Element ele = new Element("TopPhonoGrammFile");
              ele.setAttribute("uri",uri);
      rootElement.addContent(ele);        }


      out.output(doc, outStream);
    }
    catch (Exception ttt) {ttt.printStackTrace();}
  }

  public static void main(String [] args) throws Exception {





  }
}