package fr.jussieu.linguist.depLin;

import java.awt.event.*;
import java.awt.Frame.*;

import java.net.*;

import javax.sound.sampled.*;
import java.net.*;
import javax.swing.*;
import java.io.*;
import java.util.Iterator;
import java.util.*;
import javax.swing.tree.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;


import org.jdom.*;

import java.awt.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class TopPhonoPanel extends CorrespondencePanel {


     String[] sortChoices = {"topological order", "alphabetical order", "quality order"};

     TopPhonoRulesEditor tphre;


     public TopPhonoPanel(DepLinFrame frame) {
       this.depLinFrame =frame;
       inputType = "topology";
       outputType = "phonology";
       grammarType = "topPhonoGramm";

       try {
         jbInit();
	    specialInit();

	}
	catch(Exception ex) {
	    ex.printStackTrace();
	}
    }
    //////////////////////////////////////////////////////////////////////////////

    void specialInit()
    {
//	outputJTreeRoot = new DefaultMutableTreeNode("topological structures");
	outputRoot = new Element("phonoStructures");
	linearTextPanel.showInBig("Please choose a topological tree.");
	sortBox.setToolTipText("Select the ordering of the linearizations");
	jButtonLinearize.setText("Linearize");
	jButtonLinearize.setToolTipText("Linearize and save");
	numberLabel.setText("phonology n");
	jButtonLoadDefInput.setToolTipText("show this topological tree");
	jButtonLoadInput.setText("other topology");
	jButtonLoadInput.setToolTipText("Load topological tree");


    }


///////////////////////////////////////////////////////
// end jbinit
////////////////////////////////////////////////////////






/////////////////////////////
// la grammaire par dfaut //
/////////////////////////////

     void applyGrammar() throws
     ApplyGrammar.ApplyGrammarException
     {

       if(inputCanvas.lingTree==null)
	 return;
       gramFile=depLinFrame.dpl.getFileFromNumber(grammarType,grammarBox.getSelectedIndex());
       if(!gramFile.exists()) {depLinFrame.warn("can't find "+gramFile.toString());return;}
       TopPhonoGrammar topPhonoGrammar = new TopPhonoGrammar(gramFile,depLinFrame);
              long start = new Date().getTime();
       topPhonoGrammar.applyGrammarTo(inputCanvas.lingTree.rootEle);


//       final   DepLinProgress progress = new DepLinProgress();
//       progress.pack();
//       Dimension progSize = new Dimension(400,100);
//       progress.setSize(progSize);
//       Dimension frmSize = getSize();
//       Point loc = getLocation();
//       progress.setLocation((frmSize.width - progSize.width) / 2 + loc.x, (frmSize.height - progSize.height) / 2 + loc.y);
//       progress.progressBar.setIndeterminate(true);
//       timer = new javax.swing.Timer(1000, new ActionListener() {
//         String words;
//         public void actionPerformed(ActionEvent evt) {
//           progress.numberLabel.setText("we found "
//                                        +topPhonoGrammar.numberPhon+" phonological structures.");
//           if(!applyGrammar.isAlive() || progress.stopped)
//           {
//             applyGrammar.stopped=true;
//             timer.stop();
//             progress.dispose();
//           }
//         }
//       });
//       applyGrammar.start();
//       timer.start();
//       progress.setModal(true);
//       progress.show();
//       while(applyGrammar.isAlive())    {   }


       outputRoot = topPhonoGrammar.phonologiesRoot;

       long stop = new Date().getTime();
       long time = stop - start;

       int numberOutputs = outputRoot.getChildren().size();

       String resultText;
       String htmlText;
       if (numberOutputs == 1)  resultText = "Exactly 1 phonology was found ";
       else resultText = numberOutputs+" phonologies were found ";
       resultText += "in " + time + " milliseconds.";

       if(menuSettings.tracing)
       {
	   if(numberOutputs==1||numberOutputs==0) htmlText = "<b><font size=+1>The phonological story<br></font></b><br>";

	   else htmlText = "<b><font size=+1>The " + numberOutputs + " phonological stories</font></b><br>";
//	   htmlText +=applyGrammar.story;
       }
       else
       {
	   htmlText = "<b><font size=+1>Grammar " + gramFile + " applied.<br>";
	   htmlText += resultText + "<br>";
	   htmlText += "<i><font color='#7D007D'>Please choose the desired linearization mode.</font></i></font></b>";
       }
		  linearTextPanel.showInBig(htmlText);



//       wortEditPane.setCaretPosition(0);
       depLinFrame.statusBar.setText(resultText);

       if (numberOutputs == 0)
       {
         outputJTree.setBackground(Color.lightGray);
         outputCanvas.setBackground(Color.lightGray);
         return;

       }
       outputDoc.setRootElement(outputRoot);

       showOutput();

       currentOutputNumber = 0;
       showOutputTree();

       enableOutputToolBars(true);

     }

////////////////////////////////////////////////////////////////
//




     void editGrammar(ActionEvent e) {

	 gramFile = depLinFrame.dpl.getFileFromNumber(grammarType,grammarBox.getSelectedIndex());
	 if (tphre!=null)
	 {
           //!!
//	 if(tphre.isShowing()&&tphre.grammarChanged)
//	   if(tphre.saveQuestion()==2) // annulated ==> put things back
//	       {gramFile=tphre.grammarFile; grammarBox.setSelectedItem(gramFile.getName()); return;}
	 tphre.dispose();
	 }

	 try
	 {
	     tphre = new TopPhonoRulesEditor(grammar,gramFile,depLinFrame.dpl);
                 //(getDocFromFile(gramFile), gramFile, depLinFrame.dpl);
	     tphre.pack();

	     Dimension dreDim = tphre.getSize();
	     Dimension thisDim = getSize();
	     Point loc = getLocation();
	     tphre.setLocation(loc.x+thisDim.width-dreDim.width,loc.y+thisDim.height-dreDim.height);
	     tphre.show();

             //!!
	     tphre.saveAsbutton.addActionListener(new java.awt.event.ActionListener() {
		 public void actionPerformed(ActionEvent e) {
		     tphre.saveAsFile();
		     updateGramNameBox(depLinFrame.dpl);
		 }
	     });
	 }
	     catch (Exception eee)
	     {   eee.printStackTrace();	  }



	 }








}
